// Compiled by ClojureScript 1.9.562 {}
goog.provide('hoplon.jquery');
goog.require('cljs.core');
goog.require('hoplon.core');
hoplon.jquery.set_attributes_BANG_ = (function hoplon$jquery$set_attributes_BANG_(var_args){
var args30353 = [];
var len__24559__auto___30372 = arguments.length;
var i__24560__auto___30373 = (0);
while(true){
if((i__24560__auto___30373 < len__24559__auto___30372)){
args30353.push((arguments[i__24560__auto___30373]));

var G__30374 = (i__24560__auto___30373 + (1));
i__24560__auto___30373 = G__30374;
continue;
} else {
}
break;
}

var G__30359 = args30353.length;
switch (G__30359) {
case 2:
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__24582__auto__ = (new cljs.core.IndexedSeq(args30353.slice((3)),(0),null));
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__24582__auto__);

}
});

hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (this$,kvs){
var e = jQuery(this$);
var seq__30360 = cljs.core.seq.call(null,kvs);
var chunk__30362 = null;
var count__30363 = (0);
var i__30364 = (0);
while(true){
if((i__30364 < count__30363)){
var vec__30366 = cljs.core._nth.call(null,chunk__30362,i__30364);
var k = cljs.core.nth.call(null,vec__30366,(0),null);
var v = cljs.core.nth.call(null,vec__30366,(1),null);
var k_30376__$1 = cljs.core.name.call(null,k);
if(cljs.core.not.call(null,v)){
e.removeAttr(k_30376__$1);
} else {
e.attr(k_30376__$1,((cljs.core._EQ_.call(null,true,v))?k_30376__$1:v));
}

var G__30377 = seq__30360;
var G__30378 = chunk__30362;
var G__30379 = count__30363;
var G__30380 = (i__30364 + (1));
seq__30360 = G__30377;
chunk__30362 = G__30378;
count__30363 = G__30379;
i__30364 = G__30380;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30360);
if(temp__5278__auto__){
var seq__30360__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30360__$1)){
var c__24249__auto__ = cljs.core.chunk_first.call(null,seq__30360__$1);
var G__30381 = cljs.core.chunk_rest.call(null,seq__30360__$1);
var G__30382 = c__24249__auto__;
var G__30383 = cljs.core.count.call(null,c__24249__auto__);
var G__30384 = (0);
seq__30360 = G__30381;
chunk__30362 = G__30382;
count__30363 = G__30383;
i__30364 = G__30384;
continue;
} else {
var vec__30369 = cljs.core.first.call(null,seq__30360__$1);
var k = cljs.core.nth.call(null,vec__30369,(0),null);
var v = cljs.core.nth.call(null,vec__30369,(1),null);
var k_30385__$1 = cljs.core.name.call(null,k);
if(cljs.core.not.call(null,v)){
e.removeAttr(k_30385__$1);
} else {
e.attr(k_30385__$1,((cljs.core._EQ_.call(null,true,v))?k_30385__$1:v));
}

var G__30386 = cljs.core.next.call(null,seq__30360__$1);
var G__30387 = null;
var G__30388 = (0);
var G__30389 = (0);
seq__30360 = G__30386;
chunk__30362 = G__30387;
count__30363 = G__30388;
i__30364 = G__30389;
continue;
}
} else {
return null;
}
}
break;
}
});

hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (this$,k,v,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,this$,cljs.core.apply.call(null,cljs.core.hash_map,k,v,kvs));
});

hoplon.jquery.set_attributes_BANG_.cljs$lang$applyTo = (function (seq30354){
var G__30355 = cljs.core.first.call(null,seq30354);
var seq30354__$1 = cljs.core.next.call(null,seq30354);
var G__30356 = cljs.core.first.call(null,seq30354__$1);
var seq30354__$2 = cljs.core.next.call(null,seq30354__$1);
var G__30357 = cljs.core.first.call(null,seq30354__$2);
var seq30354__$3 = cljs.core.next.call(null,seq30354__$2);
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__30355,G__30356,G__30357,seq30354__$3);
});

hoplon.jquery.set_attributes_BANG_.cljs$lang$maxFixedArity = (3);

hoplon.jquery.set_styles_BANG_ = (function hoplon$jquery$set_styles_BANG_(var_args){
var args30390 = [];
var len__24559__auto___30407 = arguments.length;
var i__24560__auto___30408 = (0);
while(true){
if((i__24560__auto___30408 < len__24559__auto___30407)){
args30390.push((arguments[i__24560__auto___30408]));

var G__30409 = (i__24560__auto___30408 + (1));
i__24560__auto___30408 = G__30409;
continue;
} else {
}
break;
}

var G__30396 = args30390.length;
switch (G__30396) {
case 2:
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__24582__auto__ = (new cljs.core.IndexedSeq(args30390.slice((3)),(0),null));
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__24582__auto__);

}
});

hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (this$,kvs){
var e = jQuery(this$);
var seq__30397 = cljs.core.seq.call(null,kvs);
var chunk__30398 = null;
var count__30399 = (0);
var i__30400 = (0);
while(true){
if((i__30400 < count__30399)){
var vec__30401 = cljs.core._nth.call(null,chunk__30398,i__30400);
var k = cljs.core.nth.call(null,vec__30401,(0),null);
var v = cljs.core.nth.call(null,vec__30401,(1),null);
e.css(cljs.core.name.call(null,k),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));

var G__30411 = seq__30397;
var G__30412 = chunk__30398;
var G__30413 = count__30399;
var G__30414 = (i__30400 + (1));
seq__30397 = G__30411;
chunk__30398 = G__30412;
count__30399 = G__30413;
i__30400 = G__30414;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30397);
if(temp__5278__auto__){
var seq__30397__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30397__$1)){
var c__24249__auto__ = cljs.core.chunk_first.call(null,seq__30397__$1);
var G__30415 = cljs.core.chunk_rest.call(null,seq__30397__$1);
var G__30416 = c__24249__auto__;
var G__30417 = cljs.core.count.call(null,c__24249__auto__);
var G__30418 = (0);
seq__30397 = G__30415;
chunk__30398 = G__30416;
count__30399 = G__30417;
i__30400 = G__30418;
continue;
} else {
var vec__30404 = cljs.core.first.call(null,seq__30397__$1);
var k = cljs.core.nth.call(null,vec__30404,(0),null);
var v = cljs.core.nth.call(null,vec__30404,(1),null);
e.css(cljs.core.name.call(null,k),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));

var G__30419 = cljs.core.next.call(null,seq__30397__$1);
var G__30420 = null;
var G__30421 = (0);
var G__30422 = (0);
seq__30397 = G__30419;
chunk__30398 = G__30420;
count__30399 = G__30421;
i__30400 = G__30422;
continue;
}
} else {
return null;
}
}
break;
}
});

hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (this$,k,v,kvs){
return hoplon.jquery.set_styles_BANG_.call(null,this$,cljs.core.apply.call(null,cljs.core.hash_map,k,v,kvs));
});

hoplon.jquery.set_styles_BANG_.cljs$lang$applyTo = (function (seq30391){
var G__30392 = cljs.core.first.call(null,seq30391);
var seq30391__$1 = cljs.core.next.call(null,seq30391);
var G__30393 = cljs.core.first.call(null,seq30391__$1);
var seq30391__$2 = cljs.core.next.call(null,seq30391__$1);
var G__30394 = cljs.core.first.call(null,seq30391__$2);
var seq30391__$3 = cljs.core.next.call(null,seq30391__$2);
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__30392,G__30393,G__30394,seq30391__$3);
});

hoplon.jquery.set_styles_BANG_.cljs$lang$maxFixedArity = (3);

hoplon.jquery.text_val_BANG_ = (function hoplon$jquery$text_val_BANG_(var_args){
var args30423 = [];
var len__24559__auto___30426 = arguments.length;
var i__24560__auto___30427 = (0);
while(true){
if((i__24560__auto___30427 < len__24559__auto___30426)){
args30423.push((arguments[i__24560__auto___30427]));

var G__30428 = (i__24560__auto___30427 + (1));
i__24560__auto___30427 = G__30428;
continue;
} else {
}
break;
}

var G__30425 = args30423.length;
switch (G__30425) {
case 1:
return hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args30423.length)].join('')));

}
});

hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$1 = (function (e){
return e.val();
});

hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (e,v){
var v__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join('');
if(cljs.core.not_EQ_.call(null,v__$1,hoplon.jquery.text_val_BANG_.call(null,e))){
return e.val(v__$1);
} else {
return null;
}
});

hoplon.jquery.text_val_BANG_.cljs$lang$maxFixedArity = 2;

hoplon.jquery.check_val_BANG_ = (function hoplon$jquery$check_val_BANG_(var_args){
var args30430 = [];
var len__24559__auto___30433 = arguments.length;
var i__24560__auto___30434 = (0);
while(true){
if((i__24560__auto___30434 < len__24559__auto___30433)){
args30430.push((arguments[i__24560__auto___30434]));

var G__30435 = (i__24560__auto___30434 + (1));
i__24560__auto___30434 = G__30435;
continue;
} else {
}
break;
}

var G__30432 = args30430.length;
switch (G__30432) {
case 1:
return hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args30430.length)].join('')));

}
});

hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$1 = (function (e){
return e.is(":checked");
});

hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (e,v){
return e.prop("checked",cljs.core.boolean$.call(null,v));
});

hoplon.jquery.check_val_BANG_.cljs$lang$maxFixedArity = 2;

cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("hoplon.core","default","hoplon.core/default",-778824365),(function (elem,key,val){
return hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"attr","attr",-604132353),cljs.core.PersistentArrayMap.createAsIfByAssoc([key,val]));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("css","*","css/*",-1295355419),(function (elem,key,val){
return hoplon.jquery.set_styles_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("html","*","html/*",-1283138243),(function (elem,key,val){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("svg","*","svg/*",-1295405562),(function (elem,key,val){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("attr","*","attr/*",-1283077225),(function (elem,_,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("prop","*","prop/*",-1283942139),(function (elem,key,val){
var e = jQuery(elem);
return e.prop(cljs.core.name.call(null,key),val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("data","*","data/*",-1283013312),(function (elem,key,val){
var e = jQuery(elem);
return e.data(cljs.core.name.call(null,key),val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"attr","attr",-604132353),(function (elem,_,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"css","css",1135045163),(function (elem,_,kvs){
return hoplon.jquery.set_styles_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"value","value",305978217),(function() { 
var G__30437__delegate = function (elem,_,args){
var e = jQuery(elem);
return cljs.core.apply.call(null,((cljs.core._EQ_.call(null,"checkbox",e.attr("type")))?hoplon.jquery.check_val_BANG_:hoplon.jquery.text_val_BANG_),e,args);
};
var G__30437 = function (elem,_,var_args){
var args = null;
if (arguments.length > 2) {
var G__30438__i = 0, G__30438__a = new Array(arguments.length -  2);
while (G__30438__i < G__30438__a.length) {G__30438__a[G__30438__i] = arguments[G__30438__i + 2]; ++G__30438__i;}
  args = new cljs.core.IndexedSeq(G__30438__a,0,null);
} 
return G__30437__delegate.call(this,elem,_,args);};
G__30437.cljs$lang$maxFixedArity = 2;
G__30437.cljs$lang$applyTo = (function (arglist__30439){
var elem = cljs.core.first(arglist__30439);
arglist__30439 = cljs.core.next(arglist__30439);
var _ = cljs.core.first(arglist__30439);
var args = cljs.core.rest(arglist__30439);
return G__30437__delegate(elem,_,args);
});
G__30437.cljs$core$IFn$_invoke$arity$variadic = G__30437__delegate;
return G__30437;
})()
);
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"class","class",-2030961996),(function (elem,_,kvs){
var elem__$1 = jQuery(elem);
var clmap = hoplon.core.normalize_class.call(null,kvs);
var seq__30440 = cljs.core.seq.call(null,clmap);
var chunk__30441 = null;
var count__30442 = (0);
var i__30443 = (0);
while(true){
if((i__30443 < count__30442)){
var vec__30444 = cljs.core._nth.call(null,chunk__30441,i__30443);
var c = cljs.core.nth.call(null,vec__30444,(0),null);
var p_QMARK_ = cljs.core.nth.call(null,vec__30444,(1),null);
elem__$1.toggleClass(cljs.core.name.call(null,c),cljs.core.boolean$.call(null,p_QMARK_));

var G__30450 = seq__30440;
var G__30451 = chunk__30441;
var G__30452 = count__30442;
var G__30453 = (i__30443 + (1));
seq__30440 = G__30450;
chunk__30441 = G__30451;
count__30442 = G__30452;
i__30443 = G__30453;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30440);
if(temp__5278__auto__){
var seq__30440__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30440__$1)){
var c__24249__auto__ = cljs.core.chunk_first.call(null,seq__30440__$1);
var G__30454 = cljs.core.chunk_rest.call(null,seq__30440__$1);
var G__30455 = c__24249__auto__;
var G__30456 = cljs.core.count.call(null,c__24249__auto__);
var G__30457 = (0);
seq__30440 = G__30454;
chunk__30441 = G__30455;
count__30442 = G__30456;
i__30443 = G__30457;
continue;
} else {
var vec__30447 = cljs.core.first.call(null,seq__30440__$1);
var c = cljs.core.nth.call(null,vec__30447,(0),null);
var p_QMARK_ = cljs.core.nth.call(null,vec__30447,(1),null);
elem__$1.toggleClass(cljs.core.name.call(null,c),cljs.core.boolean$.call(null,p_QMARK_));

var G__30458 = cljs.core.next.call(null,seq__30440__$1);
var G__30459 = null;
var G__30460 = (0);
var G__30461 = (0);
seq__30440 = G__30458;
chunk__30441 = G__30459;
count__30442 = G__30460;
i__30443 = G__30461;
continue;
}
} else {
return null;
}
}
break;
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"toggle","toggle",1291842030),(function (elem,_,v){
return jQuery(elem).toggle(cljs.core.boolean$.call(null,v));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"slide-toggle","slide-toggle",968641513),(function (elem,_,v){
if(cljs.core.truth_(v)){
return jQuery(elem).hide().slideDown("fast");
} else {
return jQuery(elem).slideUp("fast");
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"fade-toggle","fade-toggle",-1468421852),(function (elem,_,v){
if(cljs.core.truth_(v)){
return jQuery(elem).hide().fadeIn("fast");
} else {
return jQuery(elem).fadeOut("fast");
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"focus","focus",234677911),(function (elem,_,v){
return setTimeout((function (){
if(cljs.core.truth_(v)){
return jQuery(elem).focus();
} else {
return jQuery(elem).focusout();
}
}),(0));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"select","select",1147833503),(function (elem,_,___$1){
return jQuery(elem).select();
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"focus-select","focus-select",1107982934),(function (elem,_,v){
if(cljs.core.truth_(v)){
hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"focus","focus",234677911),v);

return hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"select","select",1147833503),v);
} else {
return null;
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"text","text",-1790561697),(function (elem,_,v){
return jQuery(elem).text([cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"html","html",-998796897),(function (elem,_,v){
return jQuery(elem).html(v);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"scroll-to","scroll-to",-34957602),(function (elem,_,v){
if(cljs.core.truth_(v)){
var body = jQuery("body,html");
var elem__$1 = jQuery(elem);
return body.animate(cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"scrollTop","scrollTop",-1143661921),elem__$1.offset().top], null)));
} else {
return null;
}
}));
jQuery.Event.prototype.cljs$core$IDeref$ = cljs.core.PROTOCOL_SENTINEL;

jQuery.Event.prototype.cljs$core$IDeref$_deref$arity$1 = (function (this$){
var this$__$1 = this;
return jQuery(this$__$1.target).val();
});
cljs.core._add_method.call(null,hoplon.core.on_BANG_,new cljs.core.Keyword("hoplon.core","default","hoplon.core/default",-778824365),(function (elem,event,callback){
return hoplon.core.when_dom.call(null,elem,(function (){
return jQuery(elem).on(cljs.core.name.call(null,event),callback);
}));
}));
cljs.core._add_method.call(null,hoplon.core.on_BANG_,new cljs.core.Keyword("html","*","html/*",-1283138243),(function (elem,event,callback){
return hoplon.core.when_dom.call(null,elem,(function (){
return jQuery(elem).on(cljs.core.name.call(null,event),callback);
}));
}));
